<template>
  <a
    target="_blank"
    rel="nofollow noreferrer noopener"
    :href="contentOnOwnInstanceURL(group.url, userInstance.instanceRedirectURI)"
    :title="$gettext('Discover this group on %{host}', { host })"
    :class="`flex flex-col items-center bg-white rounded-lg ${
      hasBorder ? 'border dark:border-gray-700 shadow-md' : ''
    } ${
      isRowMode ? 'md:flex-row' : 'md:flex-col'
    } my-4 hover:bg-gray-100 dark:bg-gray-800 dark:hover:bg-gray-700`"
  >
    <img
      v-if="group.avatar && !bannerLoadingError"
      class="p-2 md:p-4 object-cover h-40 w-40 rounded-full md:h-40 md:w-40"
      :src="group.avatar"
      @error="bannerLoadingError = true"
      alt=""
    />
    <img
      v-else
      class="p-2 md:p-4 object-cover h-40 w-40 rounded-full md:h-40 md:w-40"
      :src="`https://avatars.joinmobilizon.org/avatar.php?seed=${encodeURIComponent(
        federatedUsername
      )}`"
      alt=""
    />

    <div
      class="flex self-start flex-col justify-between p-2 md:p-4 leading-normal w-full"
    >
      <h2
        class="font-bold tracking-tight text-gray-900 dark:text-white"
        :class="{
          'line-clamp-2 text-xl': minimal,
          'line-clamp-3 text-2xl': !minimal,
        }"
      >
        {{ group.displayName }}
      </h2>

      <p class="mb-2 text-gray-700 dark:text-gray-400 truncate max-w-[90vw]">
        {{ federatedUsername }}
      </p>
      <router-link
        :to="{
          ...$route,
          query: {
            ...$route.query,
            lat: group.location.location.lat,
            lon: group.location.location.lon,
            locationName: group.location.address.addressLocality,
          },
        }"
        v-if="group.location && !minimal"
        :title="
          $gettext('View more groups near %{locality}', {
            locality: group.location.address.addressLocality,
          })
        "
        class="flex gap-1 text-gray-700 dark:text-gray-400 hover:underline"
      >
        <svg
          width="24"
          height="24"
          stroke-width="1.5"
          viewBox="0 0 24 24"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
          class="stroke-red-300 fill-transparent"
        >
          <path
            d="M20 10C20 14.4183 12 22 12 22C12 22 4 14.4183 4 10C4 5.58172 7.58172 2 12 2C16.4183 2 20 5.58172 20 10Z"
            stroke-width="1.5"
          />
          <path
            d="M12 11C12.5523 11 13 10.5523 13 10C13 9.44772 12.5523 9 12 9C11.4477 9 11 9.44772 11 10C11 10.5523 11.4477 11 12 11Z"
            stroke-linecap="round"
            stroke-linejoin="round"
          />
        </svg>

        <span
          v-if="
            group.location.name !== group.location.address.streetAddress &&
            group.location.name !== group.location.address.addressLocality &&
            group.location.address.addressLocality
          "
        >
          {{ group.location.address.addressLocality }},
          {{ group.location.address.addressCountry }}
        </span>
        <span v-else-if="!group.location.address.addressLocality">
          {{ group.location.name }},
          {{ group.location.address.addressCountry }}
        </span>
        <span v-else>
          {{ group.location.address.addressLocality }},
          {{ group.location.address.addressCountry }}
        </span>
      </router-link>
      <!-- eslint-disable-next-line vue/no-v-html -->
      <div
        v-if="!minimal"
        class="mb-3 line-clamp-3 font-normal text-gray-700 dark:text-gray-400 child:hidden"
        v-html="group.description"
      />
      <p v-if="group.memberCount > 0">
        <span
          class="bg-blue-100 text-blue-800 text-xs font-semibold mr-2 px-2.5 py-0.5 rounded dark:bg-blue-200 dark:text-blue-800"
          >{{
            $ngettext(
              'One member',
              '%{memberCount} members',
              group.memberCount,
              { memberCount: group.memberCount }
            )
          }}</span
        >
      </p>
    </div>
  </a>
</template>

<script setup lang="ts">
  import { EnhancedGroup } from '../../../../server/types/group.model'
  import { computed, inject, ref } from 'vue'
  import { contentOnOwnInstanceURL } from '../../plugins/preferredInstance'
  import { UserInstanceData } from '../../../../shared/remote-instance'

  const props = withDefaults(
    defineProps<{
      group: EnhancedGroup
      viewMode?: 'row' | 'column'
      minimal?: boolean
      hasBorder?: boolean
    }>(),
    {
      viewMode: 'row',
      minimal: false,
      hasBorder: true,
    }
  )

  const isRowMode = computed<boolean>(() => props.viewMode == 'row')

  const bannerLoadingError = ref(false)

  const host = computed(() => {
    const url = props.group.url

    return new URL(url as string).host
  })
  const federatedUsername = computed(() => `${props.group.name}@${host.value}`)

  const userInstance = inject<UserInstanceData>('userInstance')
</script>
